#############################################################################
#############################################################################
#
# latexMode.tcl (called from modes.tcl at startup)
#
#############################################################################
#############################################################################

# LaTeX version installation:
set latexVersion "2e"
catch { enableMenuItem install "LaTeX 2e" off }
catch { enableMenuItem install "LaTeX 2.09" on }

# Initialize TeX mode:
addMode TeX dummyTeX {*.tex *.ltx *.dtx *.ins *.cls *.clo *.sty *.log *.aux *.bbl *.idx *.ind *.glo *.gls *.toc *.lof *.lot *.blg *.ilg } latexMenu
# set dummyProc(TeX) dummyTeX

# Initialize LaTeX menu:
addMenu latexMenu
set latexMenu "270"
# set modeMenus(TeX) latexMenu

# Reset the search path so it will be rebuilt the next time it's needed:
set TeXSearchPath {}

# Initialize TeX-related application signatures:
foreach app {tex viewDVI printDVI dvips viewPS printPS bibtex makeindex} {
	if { ![info exists ${app}Sig] } {
		set ${app}Sig {}
	}
}

# Install the short LaTeX menu, by default:
set useShortLaTeXMenu 1

# Global variable for reference completion:
set __wc__insPos -1

# Clean up temporary files:
proc removeTemporaryFiles {} {
	global PREFS
	if { [file exists "$PREFS:tmp"] } {
		foreach f [glob -nocomplain "$PREFS:tmp:*"] {
			message "removing [file tail $f]"
			removeFile $f
		}
	}
	message "all temporary files removed"
}
if { $startingUp } { removeTemporaryFiles }
