if {[file exists "$HOME:Tcl:SystemCode:calc.tcl"]} {
	set alphaLite 0
} else {
	set alphaLite 1
}

# if {[string match {*b[0-9]*} [version]] && ![file exists "Powerpete:C"]} {
# 	alertnote "This is a BETA version of Alpha. Do NOT redistribute!"
# }


#if {[regexp {[]\(\)\"\{\}\[]} $HOME]} {alertnote "Alpha may not work properly if it's pathname includes parenthesis, square brackets, double quotes, or curly braces."}
# Get name Alpha's current name.
foreach p [processes] {
	if {[lindex $p 1] == "ALFA"} {
		set ALPHA [lindex $p 0]
		break
	}
}


# Icon menu names. The number refers to the resource id of the #ics family.
set winMenu 		"263"

set globalMenus_curr	{filesetMenu icMenu mailMenu}


# A few definitions I'll need later.
proc quoteExpr str {
	regsub -all {[][\|*+()]} $str {\\&} str
	return $str
}

proc quoteExpr2 str {
	regsub -all {[][\$^|*+()\{\}]} $str {\\&} str
	return $str
}

#===============================================================================

set auto_path [list $HOME:Tcl:SystemCode $HOME:Tcl:UserCode $HOME:Tcl:Modes $HOME:Tcl:Menus]


source "$HOME:Tcl:SystemCode:library.tcl"

source "$HOME:Tcl:SystemCode:menus.tcl"
source "$HOME:Tcl:SystemCode:keyBindings.tcl"
source "$HOME:Tcl:SystemCode:definitions.tcl"
source "$HOME:Tcl:SystemCode:procs.tcl"
source "$HOME:Tcl:SystemCode:flags.tcl"
source "$HOME:Tcl:SystemCode:modes.tcl"
source "$HOME:Tcl:SystemCode:copyRing.tcl"

# Bogus, but needs to be before userStartup read.
set cwSig MMCC
set cwdSig MWDB

set useEmacs 1

# Read both scalar and array definitions from preferences folder.
if {!$skipPrefs} {
	catch {readUserDefs}
}

# After userprefs read.
source "$HOME:Tcl:SystemCode:emacs.tcl"

# Set up color indices
foreach ind [array names colorInds] {
	eval setRGB $ind $colorInds($ind)
}

foreach m $globalMenus_curr {
	if {![catch $m]} {
		insertMenu [set $m]
	}
}

updateSuffixes
buildRecentFiles


if {![info exists readReadme] || ($readReadme != [string trim [lindex [version] 2] {,}])} {
	addDef readReadme [string trim [lindex [version] 2] {,}]
	edit -r "$HOME:Help:Readme"
} else {unset readReadme}


if !$alphaLite {
	source "$HOME:Tcl:SystemCode:paths.tcl"
	source "$HOME:Tcl:SystemCode:smarterSource.tcl"
}

setupPrintMenu
rebuildMacroMenu

# "Switch To" submenu...
buildSwitches

# Add to chars considered part of words.
addAlphaChars {_}



message "Initialization Complete"



